package gregapi.block.tree;

import static gregapi.data.CS.T;
import static gregapi.data.CS.TOOL_axe;
import gregapi.data.OP;
import gregapi.render.IIconContainer;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

/**
 * @author Gregorius Techneticies
 */
public abstract class BlockBaseLog extends BlockBaseTree {
	public BlockBaseLog(Class<? extends ItemBlock> aItemClass, String aNameInternal, Material aMaterial, SoundType aSoundType, IIconContainer[] aIcons) {
		super(aItemClass, aNameInternal, aMaterial, aSoundType, aIcons);
	}
	
	@Override public String getHarvestTool(int aMeta) {return TOOL_axe;}
	@Override public int damageDropped(int aMeta) {return aMeta & 3;}
	@Override public int getDamageValue(World aWorld, int aX, int aY, int aZ) {return aWorld.getBlockMetadata(aX, aY, aZ) & 3;}
	@Override public float getBlockHardness(World aWorld, int aX, int aY, int aZ) {return Blocks.log.getBlockHardness(aWorld, aX, aY, aZ);}
	@Override public float getExplosionResistance(int aMeta) {return Blocks.log.getExplosionResistance(null);}
	@Override public int getItemStackLimit(ItemStack aStack) {return UT.Code.bindStack(OP.log.mDefaultStackSize);}
	@Override public boolean isWood(IBlockAccess aWorld, int aX, int aY, int aZ) {return T;}
	@Override public int getRenderType() {return 31;}
	
	@Override
	public int onBlockPlaced(World aWorld, int aX, int aY, int aZ, int aSide, float aHitX, float aHitY, float aHitZ, int aMeta) {
		switch (aSide / 2) {
		case 1: return (aMeta & 3) | 8;
		case 2: return (aMeta & 3) | 4;
		}
		return aMeta & 3;
	}
	
	@Override
	public IIcon getIcon(int aSide, int aMeta) {
		switch(aMeta & 12) {
		case  4: return (aSide == 5 || aSide == 4) ? mIcons[2*(aMeta&3)].getIcon(0) : mIcons[2*(aMeta&3)+1].getIcon(0);
		case  8: return (aSide == 2 || aSide == 3) ? mIcons[2*(aMeta&3)].getIcon(0) : mIcons[2*(aMeta&3)+1].getIcon(0);
		default: return (aSide == 0 || aSide == 1) ? mIcons[2*(aMeta&3)].getIcon(0) : mIcons[2*(aMeta&3)+1].getIcon(0);
		}
	}
	
	@Override
	public void getSubBlocks(Item aItem, CreativeTabs aTab, List aList) {
		for (int i = 0; i < 4; i++) aList.add(UT.Stacks.make(aItem, 1, i));
	}
}